/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package aas0;

import java.io.*;
import java.util.*;
import platform.*;
import parameters.*;

class MHCSelector implements MessageSelector{
    //type of propagates
    Class typeP;
    //type of ok
    Class typeO;
    int level=-1;
    MHCSelector(int level){
	this.level=level;
	try{
	    typeP=Class.forName("aas0.Propagate");
	    typeO=Class.forName("parameters.DView");
	}catch(java.lang.ClassNotFoundException e){
	    e.printStackTrace();
	    System.exit(1);
	}
    }
    public boolean accepts(Message_Command message){
	Serializable arguments=message.getArguments();
	if (typeP.isInstance(arguments)){
	    if(((Propagate)arguments).level==level)
		return true;
	}else if (typeO.isInstance(arguments))
	    if(((DView)arguments).level==level)
		return true;
	return false;
    }
}
