/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package abt;
import utils.*;
class AssignmentRef implements Cloneable{
    String var;
    int level;
    public String toString(){
	return var+":"+level;
    }
    AssignmentRef(AssignmentRef ar) {
	var  =ar.var;
	level=ar.level;
    }
    AssignmentRef(String var,int[] history) {
	if(var==null){
	    MySystem.err.println("AssignmentRef:var==null");
	    MySystem.exit(1);
	}
	this.var=var;
	if((history==null)||(history.length==0)){
	    this.level=-1;MySystem.exit("assignment -1");
	}else
	    this.level=history[history.length-2];
    }
    AssignmentRef(String var,int level) {
	if(var==null){
	    MySystem.err.println("AssignmentRef:var==null");
	    MySystem.exit(1);
	}
	this.var=var;
	if(level==-1){
	    MySystem.err.println("AssignmentRef:level==-1");
	    MySystem.exit(1);
	}
	this.level=level;
    }
    boolean higherParameter(AssignmentRef ar){
	if(!var.equals(ar.var)){
	    MySystem.err.println("AssignmentRef:var==null");
	    MySystem.exit(1);
	}
	return level<ar.level;
    }
    public boolean equals(AssignmentRef ar){
	if(!var.equals(ar.var))return false;
	return level==ar.level;
    }
    public Object clone(){
	return new AssignmentRef(this);
    }
}
