/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package csp;
import java.io.*;

public abstract class CRepresentation implements Serializable{
    public Constraint owner;
    public CRepresentation(Constraint _owner){
	owner=_owner;
    }
    public abstract int getVariablesNr();
    public abstract void coverSeeds(int seedsNr);
    public abstract boolean anyFeasible(Range[] box);
    public abstract boolean isFeasible(Range[] box);
    public abstract int[] getDim();
    public abstract String getVariable(int index);
    public abstract boolean loadFile(RandomAccessFile fis,int fileType);
    //{return true;}
}
