/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import csp.*;
import parameters.*;

interface Splitter{
    void initSearch();
    int search();
    Range[] getSol();
    int getvID(String variable);
    ArrayList getNewConstraint();
    IOHashtable getvIDs();
    String[] getVariables();
    Range[] getInitialDomains();
    Constraint[] getConstraints();
    int[] getConstraintsID();
    int   getConstraintsNr();
    int   getVariablesNr();
    void resetSearch();
    int setCurrentDomains(Range[] newDomains);
    void updateCLConstraint();
}
