/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dmac;
import csp.*;
import java.util.*;
import parameters.*;

public class CN implements DObject,Cloneable{
    String var;
    Range label;
    AContext dep;
    int proposalID;

    public String toString(){
	return var+label+((dep==null)?"":("c{"+dep+"}"))+"pID="+proposalID;
    }
    CN(CN source){
	this.var=source.var;
	this.label=source.label;
	this.dep=(AContext)source.dep.clone();
	this.proposalID=source.proposalID;
    }
    CN(String var, Range label, AContext dep, int proposalID){
	this.var=var;
	this.label=label;
	if(dep==null)this.dep=new AContext();
	else this.dep=dep;
	this.proposalID=proposalID;
    }
    public boolean sameAs(CN l){
	if(dep.size()!=l.dep.size())   return false;
	Iterator it=(Iterator)dep.keys();
	while(it.hasNext()){
	    String var=(String) it.next();
	    int h=dep.getc(var);
	    int lh=l.dep.getc(var);
	    if(lh==-1) return false;
	    if(h!=lh) return false;
	}
	return true;
    }
//     public boolean hasLevel(int level){
// 	Iterator it=(Iterator)dep.keys();
// 	while(it.hasNext()){
// 	    String var=(String) it.next();
// 	    int[] h=dep.geth(var);
// 	    if(h[h.length-2]>=level)return true;
// 	}
// 	return false;
//     }
    Assignment getA(){
	return dep.getA(var);
    }
    String getVariable(){return var;}
    boolean isNogood(){
	return label.size()<=0;
    }
    public void addCN(CN lcn){
	if(label.restricting(lcn.label)){
	    if(lcn.label.restricting(label)){
		label.restrict(lcn.label);
		dep.putAll(lcn.dep);
		return;
	    }
	    label=lcn.label;
	    dep=(AContext)lcn.dep.clone();
	}
	if((!label.different(lcn.label))&&
	   (dep.size()>lcn.dep.size())){
	    label=lcn.label;
	    dep=(AContext)lcn.dep.clone();	    
	}
    }
    //true if old null
    public static boolean olderFirstThanSecond(CN h,CN l){
	if(h==null)return true;
	return h.proposalID<l.proposalID;
    }
    public Object clone(){
	return new CN(this);
    }
}
