/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dmhc;
import platform.*;
import sjavap.*;
import utils.*;

class CompactorTriggerForInput implements ActionTrigger{
    MHCAgent agent;
    MessageQueue messageQueue;
    int thresholdL, thresholdU;
    boolean activ=false;
    final static int Delta = 10;
    CompactorTriggerForInput(MHCAgent target, MessageQueue queue, int thresholdL, int thresholdU){
	agent=target;
	messageQueue=queue;
	this.thresholdL=thresholdL;
	this.thresholdU=thresholdU;
    }
    public void actionAtChoice(){
	activ=false;
	agent.Synch_Reply();
    }
    public boolean removeAtChoice(){
	return false;
    }
    public synchronized boolean active(){
	int dimension=messageQueue.size();
	if(activ){
	    if(dimension<thresholdL){
		MySystem.err.println("CompactorTriggerForInput:active:size="+dimension);
		return true;
	    }
	}else{
	    if(dimension>thresholdU-Delta){
		MySystem.err.println("CompactorTriggerForInput:activeated:size="+dimension);
		activ=true;
	    }
	}
	return false;
    }
    public int getProcedureID(){
	return agent._compactors;
    }
    public Reply getTarget(){
	return (Reply)agent;
    }
    public int getPriority(){
	return 0;
    }
}
