/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import platform.*;
public class AIHashtable implements DObject,Cloneable{
    public Hashtable cOrder;
    public AIHashtable(){
	cOrder=new Hashtable();
    }
    public AIHashtable(Hashtable ht){
	cOrder=new Hashtable();
	Iterator it=(Iterator)ht.keys();
	while(it.hasNext()){
	    AgentID agent=(AgentID)it.next();
	    cOrder.put(agent,new IntObject(((IntObject)ht.get(agent)).getInt()));
	}
	//cOrder=(Hashtable)ht.clone();
    }
    public void setCOrder(Hashtable ht){
	cOrder=ht;
    }
    public Object clone(){
	return new AIHashtable(cOrder);
    }
    public boolean sameAs(AIHashtable c){
	if(c.size()!=size())
	    return false;
	Iterator it=(Iterator)cOrder.keys();
	while(it.hasNext()){
	    AgentID agent=(AgentID)it.next();
	    if((c.getI(agent)!=(getI(agent))))
		return false;
	}
	return true;
    }
    public IntObject put(AgentID agent, int pos){
	return (IntObject)cOrder.put(agent,new IntObject(pos));
    }
    public IntObject put(AgentID agent, IntObject dvh){
	return (IntObject)cOrder.put(agent, dvh);
    }
    public IntObject getIO(AgentID agent){
	return (IntObject)cOrder.get(agent);
    }
     public int getI(AgentID agent){
        IntObject io=getIO(agent);
        if(io==null) return -1;
	return getIO(agent).i;
    }
   public int size(){
	return cOrder.size();
    }
    public void clear(){
	cOrder.clear();
    }
    public Enumeration keys(){
	return cOrder.keys();
    }
    public Collection values(){
	return cOrder.values();
    }
    public Set keySet(){
	return cOrder.keySet();
    }
    public String toString(){
	String s="";
	Iterator it=(Iterator)cOrder.keys();
	while(it.hasNext()){
	    AgentID agent=(AgentID)it.next();
	    s=s+agent+getI(agent)+"\n";
	}
	return s;
    }
}
