/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.Hashtable;
import java.util.Iterator;
import utils.*;

public class DNogood implements DObject {
    public String senderName="Unknown";
    public int rang; // the number of deductions implied
    public Context view;
    public DCost cost;
    public DObject order;
    public int getLastSenderID(){
	int crtLast=-1;
	if(view==null)
	    return -1;
	Iterator it=view.values().iterator();
	while(it.hasNext()){
	    DVarHistory dv=(DVarHistory)it.next();
	    if(dv.history==null){
		MySystem.err.println("null history");
		MySystem.exit(1);//return null;
	    }
	    if((dv.history.length==0)||(dv.history.length%2>0)){
		MySystem.err.println("bad length of history for "+dv+" in "+this);
		MySystem.exit(1);//return null;
	    }
	    int cl=dv.history[dv.history.length-2];
	    //MySystem.err.println("gLS:was dealing with:"+dv);
	    if(cl>crtLast)
		crtLast=cl;
	}
	return crtLast;
    }

    public String toString(){
	String s;
	s=senderName+":Nogood of Rang: "+rang+"\n";

	String variable;
	DVarHistory dHistory;
	Iterator keys;
	keys = (Iterator) view.keys();

	while (keys.hasNext()){
	    variable = (String) keys.next();
	    dHistory=view.getDV(variable);
	    s=s+variable+
		((dHistory.range!=null)?dHistory.range.toString():"[]")+
		History.toString(dHistory.history)+"\n";
	    //"\t=["+range.getL()+"\t,"+range.getU()+"]\n";
	}
	if(order!=null)
	    s=s+":"+order.toString();
	if(cost!=null)
	    s=s+cost.toString();
	return s+"\n";
    }
}
