/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.*;
import platform.*;

public class DSearch implements DObject{
    public Hashtable agentOrder;
    public Object sortedAgents;
    public Hashtable problemByAgent;
    public Hashtable problemByVariable;
    public AgentID acceptedReceiver;
    public ArrayList acceptedSenders;
    public String[] allVariables=new String[0];
    public String toString(){
	String s="";
	s=s+"problemByAgent:";
	Iterator it=(Iterator)problemByAgent.keys();
	while(it.hasNext()){
	    Object ko=it.next();
	    s=s+"\n Agent order:"+agentOrder.get(ko).toString();
	    s=s+"\n AgentData:"+problemByAgent.get(ko).toString();
	}
	if(acceptedReceiver!=null)
	    s=s+"\nAccRecv:"+acceptedReceiver.getName();
	for(int i=0;i<acceptedSenders.size();i++){
	    s=s+"\nAccSnd:"+((AgentID)acceptedSenders.get(i)).getName();
	}
	return s;
    }
    public Object getAgentData(Object ob) {
	if(ob==null)
	    return null;
	Object ad=problemByAgent.get(ob);
	if(ad==null)
	    return null;
	return ad;
    }
}
