/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import utils.*;

public class DView implements DObject {
    public String senderName="Unknown";
    //String:MHCHistory
    public Context view=new Context();
    public Object agent;
    public DCost cost;
    public int level;
    public Order order;
    public DView(int _level){
	level=_level;
    }
    public void setAgent(Object _agent){
	agent=_agent;
    }
    public Object getAgent(){
	return agent;
    }
    public void put(String symbol, DVarHistory range){
	view.put(symbol,range);
    }
    public int size(){
	return view.size();
    }
    public Context get(){
	return view;
    }
    public String toString(){
	String s;
	s=senderName+":View:\n";
	if(view==null) return s+"null\n";
	Iterator it=(Iterator)view.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    s=s+var+(view.getDV(var)).toString()+"\n";
	}
	if(order!=null)
	    s=s+":"+order.toString();
	if(cost!=null)
	    s=s+cost.toString();
	return s+"\n";
    }
}
