/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import utils.*;

public class DWinner implements DObject {
    public DCost cost;
    public int position;
    //volume of the winner
    public int volume;
    //history of the winner
    public int history;
    //validity order
    public Order order;
    public DWinner(Order o){
	order=o;
    }
    public String toString(){
	String s;
	s="DWinner: position:"+position+";volume:"+volume+";history:"+history;
	if(order!=null)
	    s=s+":"+order.toString();
	if(cost!=null)
	    s=s+cost.toString();
	return s+"\n";
    }
}
