/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.io.Serializable;
import platform.*;
import java.util.*;

public class OutgoingAgent implements Serializable {
    public AgentID agent;
    public boolean ready=false;
    public long AcceptedID=-1;
    public ArrayList variables=new ArrayList();
    public Hashtable solution=new Hashtable();
    public OutgoingAgent(AgentID ag){
	agent=ag;
    }
    public String toString(){
	String s="";
	s=s+"ready="+(ready?"T":"F");
	if(variables!=null){
	    s=s+":variables=";
	    for(int k=0;k<variables.size();k++)
		s=s+variables.get(k)+":";
	}
	if(solution!=null)
	    s=s+"NonEmpty solution";
	return s;
    }
    public String toString(DSearch dSearch){
	String s="";
	s=s+"ready="+(ready?"T":"F");
	if((agent!=null)&&(dSearch!=null)){
	    Hashtable pA=dSearch.problemByAgent;
	    if(pA!=null){
		AgentData ad=(AgentData)pA.get(agent);
		if((ad!=null)&&(ad.name!=null))
		    s=s+":Name="+ad.name;
	    }
	}
	if(variables!=null){
	    s=s+":variables=";
	    for(int k=0;k<variables.size();k++)
		s=s+variables.get(k)+":";
	}
	if(solution!=null)
	    s=s+"Solution size="+solution.size();
	return s;
    }
    public AgentID getAgent(){
	return agent;
    }
    public void insert(String var){
	variables.add(var);
    }
}
