/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
package platform;
import sjavap.*;
import utils.MySystem;

public class ServerTriggerForInput implements ActionTrigger{
    Server server;
    MessageQueue messageQueue;
    int thresholdL,thresholdU;
    boolean activ=false;
    final static int Delta = 10;
    public ServerTriggerForInput(Object server, MessageQueue queue, int thresholdL, int thresholdU){

	this.server=(Server)server;
	messageQueue=queue;
	this.thresholdL=thresholdL;
	this.thresholdU=thresholdU;
    }
    public void actionAtChoice(){
	activ=false;
	server.Synch_Reply();
    }
    public boolean removeAtChoice(){
	return false;
    }
    public synchronized boolean active(){
	int dimension=messageQueue.size();
	if((dimension%10)==7)
	    MySystem.err.println("ServerTriggerForInput:"+(activ?"active":"inactive")+":size="+dimension+";TL="+thresholdL+";TU="+thresholdU);
	if(activ){
	    if(dimension<thresholdL){
		MySystem.err.println("ServerTriggerForInput:active");
		return true;
	    }
	}else{
	    if(dimension>thresholdU-Delta){
		activ=true;
	    }
	}
	return false;
    }
    public int getProcedureID(){
	return Server._compactors;
    }
    public Reply getTarget(){
	return (Reply)server;
    }
    public int getPriority(){
	return 0;
    }
}
