/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package smdc;
import csp.*;
import parameters.*;
import java.util.*;

class Propagation implements DObject{
    int senderID;
    int initiator;
    int[] order; //only agents after initiator need messages
    int crtConsistency;
    Range[] domains;
    String[] allVariables;
    //domains just changed
    //boolean[] inconsistentDomains=null;
    DCost cost=null;
    //agent:counters
    Hashtable counters=null;
    boolean consistencyNogood=false;
    Propagation(){}
    Propagation(int senderID, int initiator, int crtConsistency,
		Range[] domains){
	this.senderID=senderID;
	this.initiator=initiator;
	this.crtConsistency=crtConsistency;
	this.domains=domains;
    }
    public String toString(){
	String s="sndID:"+senderID+" initID:"+initiator+" crtCons:"+crtConsistency+" "+(consistencyNogood?"NG ":"")+((counters!=null)?"cntrs:"+counters.size():"");
	for(int k=0;k<domains.length;k++)
	    s=s+":"+((domains[k]==null)?"":(allVariables[k]+domains[k].toString()));
	for(int k=0;k<order.length;k++)
	    s=s+":"+order[k];
	return s;
    }
}
