/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package utils;
import java.io.PrintStream;

public class MyPrintStream{
    public static boolean messages=true;
    public PrintStream ps=System.out;
    public int errors=0;
    Object streamMonitor=new Object();
    Object errorsMonitor=new Object();
    public MyPrintStream(PrintStream ips) {
	if(ips!=null)
	    ps=ips;
    }
    boolean todo(){
        if(!messages)
            return false;
	if(ps==System.out)
	    return true;
	else
	    return true;
    }
    public void print(Object ob) {
	try{
	    synchronized(streamMonitor){
		if(todo()) ps.print(ob);
	    }
	}catch(IllegalMonitorStateException e) {
	    synchronized(errorsMonitor){
		errors++;
	    }
	}
    }
    public void flush() {
	ps.flush();
    }
    public void print(int val) {
	try{
	    synchronized(streamMonitor){
		if(todo()) ps.print(val);
	    }
	}catch(IllegalMonitorStateException e) {
	    synchronized(errorsMonitor){
		errors++;
	    }
	}
    }
    public void println(Object ob) {
	try{
	    synchronized(streamMonitor) {
		if(todo())
		    ps.println(ob);
	    }
	}catch(IllegalMonitorStateException e) {
	    synchronized(errorsMonitor){
		errors++;
	    }
	}
    }
    public void println(int val) {
	try{
	    synchronized(streamMonitor) {
		if(todo())
		    ps.println(val);
	    }
	}catch(IllegalMonitorStateException e) {
	    synchronized(errorsMonitor){
		errors++;
	    }
	}
    }
    public void println() {
	try{
	    synchronized(streamMonitor){
		if(todo()) ps.println();
	    }
	}catch(IllegalMonitorStateException e) {
	    synchronized(errorsMonitor){
		errors++;
	    }
	}
    }
}
