/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package utils;

import java.io.*;
import java.util.*;
import java.awt.*;
import parameters.*;

public class Utils {
    public Utils(){}
    public static int MAX_SECV_MSG=20000;
    public static Object agentCost=new DCost();
    public static boolean sendingColors=true;
    public final static Color transparent=Color.red;
    public final static Color instantiation=Color.blue;
    public final static short nullElement=-10;
    // all solutions
    public final static boolean allSolutions=false;
    // aggregations
    public static boolean aggregations=false;
    // yokoo (sending only owners)
    public final static boolean yokoo=false;
    // sending nogoods to the last being the first
    // to manage a variable
    public final static boolean nogoodToLastFirst=false;
    // first iff owned
    public final static boolean firstOwned=false;
    // agrregations constrained
    public final static boolean constrained=false;
    // agregations constrained on internal
    public final static boolean inversConstrained=false;
    public static boolean isYokoo(){
	return yokoo;
    }
    static String ERROR="";
    static String buf="";
    static StringTokenizer st= new StringTokenizer("");
    public static String getNextToken(RandomAccessFile fis){
	String s;
	//System.out.println("New recursion");
	try {
	    s=st.nextToken();
	    //System.out.println("token: \""+s+"\"");
	    if(s.equals("#")){
		//System.out.println("token: \""+s+"\" is discarded");
		// reset line buffer
		st=new StringTokenizer("");
		return getNextToken(fis);
	    }
	    return s;
	}catch (NoSuchElementException e){
	    try {
		buf=fis.readLine();
		if(buf==null){
		    System.err.println("EOF encountered");
		    return ERROR;
		}
		st= new StringTokenizer(buf);
		//MySystem.out.println("New line: \""+buf+"\"");
	    }catch (IOException evt){
		System.err.println("Utils:getNextT:"+evt);
		e.printStackTrace();
		return ERROR;
	    }
	    return getNextToken(fis);
	}
    }
    public static String getNextToken(RandomAccessFile fis, String terminators, boolean returnTokens){
	String s;
	try {
	    s=st.nextToken(terminators);
	    //MySystem.out.println("token: \""+s+"\"");
	    if(s.equals("#")){
		// reset line buffer
		st=new StringTokenizer("");
		return getNextToken(fis,terminators,returnTokens);
	    }
	    return s;
	}catch (NoSuchElementException e){
	    try {
		buf=fis.readLine();
		st= new StringTokenizer(buf,terminators,returnTokens);
	    }catch (IOException evt){
		System.err.println("Utils:gNT"+evt);
		e.printStackTrace();
		return ERROR;
	    }
	    return getNextToken(fis,terminators,returnTokens);
	}
    }
    void cmp(String s1, String s2){
	byte b1[]=s1.getBytes();
	byte b2[]=s2.getBytes();
	int k;
	System.out.println("Comparing "+s1+" to "+s2);
	for(k=0;k<b1.length; k++)
	    System.out.print(b1[k]+":");
	System.out.println("EOL");
	for(k=0;k<b2.length; k++)
	    System.out.print(b2[k]+":");
	System.out.println("EOL");
    }
    public static int getInt(RandomAccessFile fis){
	String s;
	s=getNextToken(fis);
	int i=0;
	try {
	    i=Integer.parseInt(s);
	}catch (Exception e) {
	    MySystem.err.println("Integer Conversion Error on \""+s+"\"");
	    MySystem.exit(1);
	    return 0;
	}
	return i;
    }
    public static String getString(RandomAccessFile fis, int maxlength, String terminators){
	return getNextToken(fis,terminators,false);
    }
    public static String getDelimString(RandomAccessFile fis, String terminators){
	return getNextToken(fis,terminators,true);
    }
    public static String getStack(){
	String s=null;
	try{
	    throw new Exception();
	}catch(Exception e){
	    ByteArrayOutputStream os=new ByteArrayOutputStream();
	    e.printStackTrace(new PrintStream(os));
	    s=os.toString();
	}
	return s;
    }
    public static String getString(RandomAccessFile fis){
	return getNextToken(fis);
    }
    public static void runFinal(String s){
	//MySystem.out.println("FINALIZE:"+s);
    }
}
