/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package csp;
import java.io.Serializable;

public class Variable implements Serializable {
    String variable;
    boolean owner;
    Variable(String _variable){
	owner=false;
	variable=_variable;
    }
    Variable(String _variable, boolean _owner){
	owner=_owner;
	variable=_variable;
    }
    public String getName() {
	return variable;
    }
    public String getVariable() {
	return variable;
    }
    public boolean isOwner() {
	return owner;
    }
    public String toString() {
	String s="";
	if(variable!=null)
	    s=s+variable+":own=";
	if(owner)
	    s=s+"1";
	else s=s+"0";
	return s;
    }
}
