/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import platform.*;
import utils.*;
import sjavap.*;

public class Cluster extends Protocol{
    static boolean ascendingOrder=true;
    protected Class getAgentProtocolClass(){
	try{
	    ascendingOrder=true;
	    return Class.forName("dcsp.PAgent");
	}catch(ClassNotFoundException e){
	    MySystem.exit(1);
	}
	return null;
    }
    protected Class getBrokerProtocolClass(){
	try{
	    ascendingOrder=true;
	    return Class.forName("dcsp.PBroker");
	}catch(ClassNotFoundException e){
	    MySystem.exit(1);
	}
	return null;
    }
    public void run(){
	return;
    }
    public synchronized void getMessage(Message message){
        Synch_Reply();
	return;
    }
    public synchronized void terminate(){
        Synch_Reply();
	return;
    }
    public String toString(){
	return "DCSP";
    }
}
