/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import platform.*;
import sjavap.*;
import utils.*;

class CompactorTriggerForOutput implements ActionTrigger{
    PAgent agent;
    MessageQueue messageQueue;
    int threshold;
    final static int Delta = 10;
    boolean activ=false;
    CompactorTriggerForOutput(PAgent target, MessageQueue queue, int threshold){
	agent=target;
	messageQueue=queue;
	this.threshold=threshold;
    }
    public void actionAtChoice(){
	activ=false;
	agent.Synch_Reply();
    }
    public boolean removeAtChoice(){
	return false;
    }
    public synchronized boolean active(){
	int dimension=messageQueue.size();
	if((dimension%10)==7)
	    MySystem.out.println("CompactorTriggerForOutput:"+(activ?"active":"inactive")+":size="+dimension);
	if(activ){
	    if(dimension<threshold){
		//MySystem.out.println("CompactorTriggerForOutput:active:size="+dimension);
		return true;
	    }
	}else{
	    if(dimension>threshold-Delta){
		MySystem.out.println("CompactorTriggerForOutput:activated:size="+dimension);
		activ=true;
	    }
	}
	return false;
    }
    public int getProcedureID(){
	return agent._compactors;
    }
    public Reply getTarget(){
	return (Reply)agent;
    }
    public int getPriority(){
	return 0;
    }
}
