/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dmac;
import java.util.*;
import parameters.*;
import csp.*;

public class AContext implements DObject,Cloneable{
    public Hashtable context;
    public AContext(){
	context=new Hashtable();
    }
    public AContext(Hashtable ht){
	context=new Hashtable();
	Iterator it=(Iterator)ht.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    context.put(var,(DVarHistory)((DVarHistory)ht.get(var)).clone());
	}
	//context=(Hashtable)ht.clone();
    }
    public Object clone(){
	return new AContext(context);
    }
    public boolean sameAs(AContext c){
	if(c.size()!=size())
	    return false;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Range cmp=c.getR(var);
	    if((cmp==null)||(cmp.different(getR(var))))
		return false;
	}
	return true;
    }
    Assignment put(String var, Range range, int hist){
	return (Assignment)context.put(var,new Assignment(var,range,hist));
    }
    public Assignment put(String var, Assignment dvh){
	return (Assignment)context.put(var, dvh);
    }
    public void putAll(AContext a){
	context.putAll(a.context);
    }
    public Assignment remove(String var){
	return (Assignment)context.remove(var);
    }
    public int getc(String var){
	Assignment dv=(Assignment)context.get(var);
	if(dv==null)
	    return -1;
	return dv.counter;
    }
    public Range getR(String var){
	Range r=((Assignment)context.get(var)).value;
	if(r!=null)
	    return (Range)r.clone();
	return null;
    }
    public Assignment getA(String var){
	return (Assignment)context.get(var);
    }
    public Iterator iterator(){
	return (Iterator)context.keys();
    }
    public int size(){
	return context.size();
    }
    public void clear(){
	context.clear();
    }
    public Enumeration keys(){
	return context.keys();
    }
    public Iterator keysIterator(){
	return (Iterator)context.keys();
    }
    public Collection values(){
	return context.values();
    }
    public Set keySet(){
	return context.keySet();
    }
    public String toString(){
	String s="";
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    s=s+var+getA(var).toString();
	}
	return s;
    }
}
