/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dmhc;

import java.io.*;
import java.util.*;
import platform.*;
import utils.*;
import parameters.*;

public class Message_MHC implements Serializable{
    public int level;
    public DCost cost;
    public AgentID sender;
//x_j[v_l, v_h]:hist {x^1:hist,...,x^n:hist}
    public Labeling varHistories = new Labeling(); //MHCHistory
    public Context addedLinks = new Context();
    public Message_MHC(int level){
	this.level=level;
	cost=(DCost)Utils.agentCost;
    }
    public String toString(){
      String s="Message_MHC:level="+level;
      if(varHistories!=null)
        for(int k=0;k<varHistories.size();k++){
	  Label ob=varHistories.getL(k);
	  if(ob!=null) 
	      s=s+" "+ob;
        }
      if(addedLinks.size()>0)
	  s=s+" al:"+addedLinks;
      if(cost!=null)
	  s=s+" "+cost.toString();
      return s;
    }
}
