/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package mas;
import java.util.Comparator;
import parameters.*;
import utils.*;

class AgentGraphComplexityComparator implements Comparator{
    // first the overall important
    // then the variable owner
    // then the most complex
    public int compare(Object o1, Object o2){
	AgentGraph ag1,ag2;
	AgentData ad1,ad2;
	ag1= (AgentGraph) o1;
	ag2= (AgentGraph) o2;
	ad1=ag1.ad;
	ad2=ag2.ad;
	//MySystem.out.print("comparing:"+ad1.name+" with "+ad2.name+":");
	int res;
	boolean before1, before2;
	res=sgn(ad2.complexity-ad1.complexity);
	//MySystem.out.println(":COMPLEXITY:"+res);
	return res;
    }
    static int sgn(int nr){
	return (nr==0)?0:(nr<0)?-1:1;
    }
}
