/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import csp.*;
import platform.*;
import utils.*;

public class AgentData implements DObject{
    public AgentID agent;
    public String name;
    public String variable;
    public Variable[] svars;
    public int importance,complexity;
    public AgentData(){}
    public String toString(){
	String s="";
	if(name!=null)
	    s=s+" Nume:"+name+":"+variable+":variables::";
	if(svars!=null)
	    for(int k=0;k<svars.length;k++){
		if(svars[k]!=null)
		    s=s+svars[k]+":";
	    }
	return s;
    }
    public boolean set(AgentID _agent, Variable _svars[], int _importance, int _complexity){
	agent=_agent;
	svars=_svars;
	importance=_importance;
	complexity=_complexity;
	try {
	    name=_agent.getName();
	}catch (Exception e){
	    MySystem.err.println("AgentDate:set:Error reaching the calling agent:"+agent);
	    MySystem.err.println(e);
	    e.printStackTrace();
	    return false;
	}
	return true;
    }
    public int getComplexity(){
	return complexity;
    }
    public int getImportance(){
	return importance;
    }
    public Variable[] getVariables(){
	return svars;
    }
    public AgentID getAgent(){
	return agent;
    }
    public String getName(){
	return name;
    }
}
