/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import platform.*;
import csp.*;

public class DSubscription implements DObject {
    public AgentID agent;
    public String name;
    public String variable;
    public Variable variables[];
    public int importance;
    public int complexity;
    //public String[] protocols;
    
    public DSubscription(AgentID _agent, Variable _variables[], int _importance, int _complexity, 
		  //String[] _protocols, 
		  String _name){
	agent=_agent;
	name=_name;
	variables=_variables;
	importance=_importance;
	complexity=_complexity;
	//protocols=_protocols;
    }
    public String toString(){
	int k;
	String s=" name: "+name+"\n";
	s=s+" complexity: "+complexity+"\n";
	s=s+" importance: "+importance+"\n";
	if(variables!=null)
	    for(k=0;k<variables.length;k++){
		s=s+" variable: "+variables[k].getVariable();
		s=s+" owner: "+(variables[k].isOwner()?1:-1)+"\n";
	    }
	/*
	if(protocols!=null)
	    for(k=0;k<protocols.length;k++){
		s=s+" protocol: "+protocols[k]+"\n";
	    }	
	*/
	return s;
    }
}
