/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import csp.*;
import parameters.*;

public class IOHashtable implements DObject,Cloneable{
    public Hashtable context;
    public IOHashtable(){
	context=new Hashtable();
    }
    public IOHashtable(Hashtable ht){
	context=new Hashtable();
	Iterator it=(Iterator)ht.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    context.put(var,(Integer)ht.get(var));
	}
    }
    public Object clone(){
	return new RHashtable(context);
    }
    public boolean sameAs(IOHashtable c){
	if(c.size()!=size())
	    return false;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Integer cmp=c.getI(var);
	    if((cmp==null)||(!cmp.equals(getI(var))))
		return false;
	}
	return true;
    }
    public Integer put(String var, Integer range){
	return (Integer)context.put(var,range);
    }
    public Integer put(String var, int range){
	return (Integer)context.put(var,new Integer(range));
    }
    public Integer remove(String var){
	return (Integer)context.remove(var);
    }
    public Integer getI(String var){
	return (Integer)context.get(var);
    }
    public int geti(String var){
	Integer io=(Integer)context.get(var);
	if(io==null) return -1;
	return io.intValue();
    }
    public int size(){
	return context.size();
    }
    public void clear(){
	context.clear();
    }
    public Enumeration keys(){
	return context.keys();
    }
    public Iterator keysIterator(){
	return (Iterator)context.keys();
    }
    public Collection values(){
	return context.values();
    }
    public Set keySet(){
	return context.keySet();
    }
    public String toString(){
	String s="";
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    s=s+var+geti(var)+"\n";
	}
	return s;
    }
}
