/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import csp.*;

public class RHashtable implements DObject,Cloneable{
    public Hashtable context;
    public RHashtable(){
	context=new Hashtable();
    }
    public RHashtable(Hashtable ht){
	context=new Hashtable();
	Iterator it=(Iterator)ht.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    context.put(var,(Range)((Range)ht.get(var)).clone());
	}
    }
    public Object clone(){
	return new RHashtable(context);
    }
    public boolean sameAs(RHashtable c){
	if(c.size()!=size())
	    return false;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Range cmp=c.getR(var);
	    if((cmp==null)||(cmp.different(getR(var))))
		return false;
	}
	return true;
    }
    public int getSize(){
	int vol=1;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Range dv=getR(var);
	    vol*=dv.size();
	}
	return vol;
    }
    public Range put(String var, Range range){
	return (Range)context.put(var,range);
    }
    public void putAll(RHashtable rh){
	context.putAll(rh.context);
    }
    public Range remove(String var){
	return (Range)context.remove(var);
    }
    public Range getR(String var){
	return (Range)context.get(var);
    }
    public int size(){
	return context.size();
    }
    public void clear(){
	context.clear();
    }
    public Enumeration keys(){
	return context.keys();
    }
    public Iterator keysIterator(){
	return (Iterator)context.keys();
    }
    public Collection values(){
	return context.values();
    }
    public Set keySet(){
	return context.keySet();
    }
    public String toString(){
	String s="";
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    s=s+var+getR(var).toString()+"\n";
	}
	return s;
    }
}
