/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
/**
 * @(#)Message_EndProtocol.java  1.0 00/02/05
 *
 * Intelligent Agents Collaborating in Distributed Problem Solving
 *
 * Supervisors:   Marius-Calin Silaghi, Djamila Sam-Haroud 
 * Author:        Michel Galley
 */

package platform;

import java.io.*;

/**
 * Platform-dependent message sent by the broker to agents asking them
 * to kill their protocol objects and to prepare for a new computation.
 *
 * @author Michel Galley
 * @see Message
 * @version 1.0 00/02/05 
 */

class Message_EndProtocol extends Message
{
    Message_EndProtocol() { super(); }
    Message_EndProtocol(AgentID receiverID)
    {
	super(receiverID);
    }    

    public String _toString() { return "End protocol"; }
    public void _writeMessage(DataOutputStream out) throws IOException {}
    public int _size() { return 0; }
    public void _readMessage(DataInputStream in) throws IOException {}
}    
