/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package smdc;
import csp.*;
import parameters.*;
import java.util.*;

class OrderMessage implements DObject{
    int senderID;
    int[] order; //only agents after initiator need messages
    int crtConsistency;
    Range[] domains;
    String[] allVariables=null;
    DCost cost;
    OrderMessage(){}
    OrderMessage(int senderID, int[] order, int crtConsistency,
		 Range[] domains){
	this.senderID=senderID;
	this.order=order;
	this.crtConsistency=crtConsistency;
	this.domains=domains;
    }
    public String toString(){
	String s="senderID:"+senderID+" crtCons:"+crtConsistency+" ";
	for(int k=0;k<domains.length;k++)
	    s=s+":"+((domains[k]==null)?"":(allVariables[k]+domains[k].toString()));
	for(int k=0;k<order.length;k++)
	    s=s+":"+order[k];
	return s;
    }
}
