/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package smdc;

import java.io.*;
import java.util.*;
import platform.*;
import utils.*;

public class SubscriptionSelector implements MessageSelector{
    Class type;
    SubscriptionSelector(){
	try{
	    type=Class.forName("parameters.DSubscription");
	}catch(java.lang.ClassNotFoundException e){
	    e.printStackTrace();
	    System.exit(1);
	}
    }
    public boolean accepts(Message_Command message){
	if(message==null)
	    MySystem.out.println("Null?");
	//MySystem.out.println("Is Subscription?:"+message.getCommand());
	if (type.isInstance(message.getArguments())){
	    //MySystem.out.println("Subscription:"+message.getCommand());
	    return true;
	}
	//MySystem.out.println("No Subscription:"+message.getCommand());
	return false;
    }
}
